/*************************************************************
*	PROGETTO LABIRINTO
*
* nome file: <coda.c>
*
* Autori:
* Thomas Carrabs
* Roberto Pisoni
*
* Progetto realizzato per l'esame di Geometria Computazionale
* e di Informatica Grafica presso il Dipartimento di Scienze
* dell'Informazione dell'universit Statale di Milano
*
* Tutto il codice  distribuito sotto licenza Gnu/GPL
* http://www.gnu.org/copyleft/gpl.html
* una copia della licenza si trova nella cartella License del
* Progetto
*
*************************************************************/


#include "labirinto.h"
#include "coda.h"

//Funzione che crea la coda
void creaCoda(coda *coda){
	coda->ctr   = 0;		//contatore elementi della coda
	coda->top   = NULL;	//puntatore elemento in cima alla coda
	coda->fondo = NULL;	//puntatore elemento in fondo alla coda
}

//Funzione che pone un elemento nella coda
void mettiCoda(coda *coda, cella *pcella){
	struct coda_cella *c;
	
	//Crea un elemento di tipo coda_cella da porre nella coda
	if((c=calloc(1,sizeof(struct coda_cella)))==NULL){
		printf("Errore nella creazione di un elemento nella coda");
		exit(0);
	}
	c->id = pcella->id;		//aggiorna id della cella
	c->next = NULL;
	if(coda->ctr==0)				//se la coda  vuota...
		coda->top=coda->fondo=c;	//ho inserito il 1o elemento e quindi top e fondo puntano alla stessa cella
	else{
		coda->fondo->next =c;		//altrimenti fondo punta alla nuova cella
		coda->fondo=c;
	}
	coda->ctr++;		// stato aggiunto un elemento alla coda
}

//Funzione che prende l'elemento in fondo alla coda (il 1o inserito)
int togliCoda(coda *coda){	
	struct coda_cella *ptrcella;
	int id_cella;
	
	id_cella = coda->top->id;		//ritorna l'ID corretto della cella in cima alla coda
	ptrcella = coda->top;			//ptrcella punta all'elemento in cima alla coda
	coda->top=coda->top->next;		//aggiorno il ptr al primo elemento dello stack (successivo a quello attuale)
	coda->ctr--;					//decremento di 1 gli elementi della coda
	free(ptrcella);
	return id_cella;				//id cella in cima allo stack
}
