/*************************************************************
*	PROGETTO LABIRINTO
*
* nome file: <engine.h>
*
* Autori:
* Thomas Carrabs
* Roberto Pisoni
*
* Progetto realizzato per l'esame di Geometria Computazionale
* e di Informatica Grafica presso il Dipartimento di Scienze
* dell'Informazione dell'universit Statale di Milano
*
* Tutto il codice  distribuito sotto licenza Gnu/GPL
* http://www.gnu.org/copyleft/gpl.html
* una copia della licenza si trova nella cartella License del
* Progetto
*
*************************************************************/

#include "geometria.h"
#include "labirinto.h"
#define dMeshH 10 /*numero di intervalli in cui dividere orizzontalmente i pannelli*/
#define dMeshV 10 /*numero di intervalli in cui dividere verticalmente i pannelli*/

void init_Mappa(void);
/*
 * Crea una display list per la mappa 2D del labirinto.
 * Le celle sono disegnate a met: solo il muro inferiore e quello sx
 * se presenti. Il muro superiore e il destro vengono disegnati dalle celle vicine
 * La Cella maze.n*maze.m  una cella fasulla, utilizzata per disegnare il muro superiore
 * e destro dell'intero labirinto
 */

void init_Labirinto3D(void);
/*
 * Crea una display list per i muri 3D del labirinto.
 * Il processo utilizzato per disegnare i muri di una singola cella
 *  lo stesso della mappa 2D.
 */


void init_Soluzione(void);
/*
 * Crea una display list per la soluzione del labirinto
 * da visualizzare nella mappa 2D
 */


void init_Pavimento(void);
/*
 * Crea una display List per il pavimento
 */


void init_Soffitto(void);
/*
 * Crea una display list per il soffitto
 */

short int caricaTexture(char *nomefile,GLubyte *ptr_texels);
/*
 * Funzione per caricare una bmp nel programma
 */

short int init_Texture(void);
/*
 * Questa funzione verifica l'esistenza e carica le texture
 * 
 */

void draw_Pannel(float w, float h, int rows, int cols, int xp, int zyp, int quota);
/*
 * Disegna un quadrato sul piano xz come strip di quadrati
 * in maniera da ottenere un quadrato con mesh dipendente dalla densit
 * specificata in engine.h
 */

void draw_pillar(int xp, int zyp);
/*
 * Funzione per disegnare i pilastri
 */

void draw_1(int xp, int zyp);
void draw_2(int xp, int zyp);
void draw_3(int xp, int zyp);
void draw_4(int xp, int zyp);
void draw_5(int xp, int zyp);
void draw_6(int xp, int zyp);
void draw_7(int xp, int zyp);
void draw_8(int xp, int zyp);
void draw_9(int xp, int zyp);
void draw_10(int xp, int zyp);
void draw_11(int xp, int zyp);
void draw_12(int xp, int zyp);
void draw_13(int xp, int zyp);
void draw_14(int xp, int zyp);
void draw_15(int xp, int zyp);
/*
 * Funzioni per disegnare le varie tipologie di celle
 */
