/*************************************************************
*	PROGETTO LABIRINTO
*
* nome file: <labirinto.h>
*
* Autori:
* Thomas Carrabs
* Roberto Pisoni
*
* Progetto realizzato per l'esame di Geometria Computazionale
* e di Informatica Grafica presso il Dipartimento di Scienze
* dell'Informazione dell'universit Statale di Milano
*
* Tutto il codice  distribuito sotto licenza Gnu/GPL
* http://www.gnu.org/copyleft/gpl.html
* una copia della licenza si trova nella cartella License del
* Progetto
*
*************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

struct cella{
	int passaggio; 				//16 stati possibili che una cella pu assumere
	int id;						//identificativo cella id=nro righe*y+x 
	struct cella *next_cella;	//ptr cella successiva
};

typedef struct cella cella;

struct maze {
	int m, n, l;  				//dimensioni labirinto m=nro righe n=nro colonne l=dimensione blocco
	cella  *entrata, *uscita;	//ptr cella di inizio e di fine
	cella *pcella;				//ptr alla lista di adiacenza
	int *vicini;				//contatore vicini della lista d'adiacenza
};

struct cella_vis {
	short int vis;
	short int nvic;
};


short int crealista(cella *ptrcella,int dimensione,int rig,int col, int *vic);	//crea lista di adiacenza
short int creaLabirinto(struct maze *lab, int dimensione); // funzione per creare labirinto. Algoritmo DFS
int cellaBordo(int m, int n);						  // sceglie random una cella sul bordo del labirinto
int cellaUscita(int ID);							  //sceglie la cella di uscita dal labirinto 
void aggiornaVicini(struct maze *lab, int ID, struct cella_vis *vis);	//funzione per aggiornare le celle
																		//vicine nn ancora visitate.
int *soluzione(struct maze *lab);	//funzione che determina il cammino minimo per uscire dal labirinto
							
